plugin material Ludviks_VRayAlSurfaceMtl
name:"Ludviks_VRayAlSurfaceMtl"
classID:#(0x4bcb5125, 0x6fd1ba1a)
category:"V-Ray"
extends:VRayAlSurfaceMtl replaceUI:false version:1
(
	
	/*
		presetParamValuePairs is so structured: main array with as many entries as presets > each is an array with as many entries as parameters to change ->
		-> each is a tuple, or two-places array, with the parameter name and its value.
	*/
	local presetParamValuePairs=#( #( #(#reflect1_distribution,1), #(#reflect2_distribution,1) ), #( #(#reflect1_distribution,0), #(#reflect2_distribution,0) ) )
	
	fn applyPreset num =		--function which applies a preset
	(
-- 		print presetParamValuePairs[num]
		for p in presetParamValuePairs[num] do	
		(
			setProperty delegate p[1] p[2]		--"delegate" is the keyword for the material that's being extended. So this line sets the property in the specific array place to the corresponding value (see the array above)
		)
	)
	
	parameters main rollout:presetsRoll
	(
		--can be left empty for this type of exercise.
	)
	
	rollout presetsRoll "Presets Manager:" width:328 height:744 rolledup:false		--the rollout
	(
		label lbl1 "Preset:" align:#left across:2
		dropDownList presetsDdl "" width:192 height:21 offset:[-48,0] items:#("Ludvik's", "Default")
		
		on presetsRoll open do		--as the new rollout opens, when the shader is first picked, the preset selected by default ("Ludvik") is applied.
		(
-- 			applyPreset presetsDdl.selection
		)
		on presetsDdl selected sel do	--as the user changes selection of preset, it's immediately applied.
		(
			applyPreset sel
		)
	)
	
	on create do applyPreset presetsRoll.presetsDdl.selection
)
